---
title: Build the brick field
slug: Games/Tutorials/2D_breakout_game_Phaser/Build_the_brick_field
tags:
  - 2D
  - Beginner
  - Canvas
  - Games
  - JavaScript
  - Phaser
  - Tutorial
---
<div>{{GamesSidebar}}</div>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_Phaser/Game_over", "Games/Workflows/2D_Breakout_game_Phaser/Collision_detection")}}</p>

<div class="summary">
<p>This is the <strong>9th step</strong> out of 16 of the <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_Phaser">Gamedev Phaser tutorial</a>. You can find the source code as it should look after completing this lesson at <a href="https://github.com/end3r/Gamedev-Phaser-Content-Kit/blob/gh-pages/demos/lesson09.html">Gamedev-Phaser-Content-Kit/demos/lesson09.html</a>.</p>
</div>

<p><span class="seoSummary">Building the brick field is a little bit more complicated than adding a single object to the screen, although It's still easier with Phaser than in pure JavaScript. Let's explore how to create a group of bricks and print them on screen using a loop.</span></p>

<h2 id="Defining_new_variables">Defining new variables</h2>

<p>First, let's define the needed variables — add the following below your previous variable definitions:</p>

<pre class="brush: js notranslate">var bricks;
var newBrick;
var brickInfo;
</pre>

<p>The <code>bricks</code> variable will be used to create a group, <code>newBrick</code> will be a new object added to the group on every iteration of the loop, and <code>brickInfo</code> will store all the data we need.</p>

<h2 id="Rendering_the_brick_image">Rendering the brick image</h2>

<p>Next, let's load the image of the brick — add the following <code>load.image()</code> call just below the others:</p>

<pre class="brush: js notranslate">function preload() {
    // ...
    game.load.image('brick', 'img/brick.png');
}
</pre>

<p>You also need to <a href="https://github.com/end3r/Gamedev-Phaser-Content-Kit/blob/gh-pages/demos/img/brick.png">grab the brick image from Github</a> and save it in your <code>/img</code> directory.</p>

<h2 id="Drawing_the_bricks">Drawing the bricks</h2>

<p>We will place all the code for drawing the bricks inside an <code>initBricks</code> function to keep it separated from the rest of the code. Add a call to <code>initBricks</code> at the end of the <code>create()</code> function:</p>

<pre class="brush: js notranslate">function create(){
    // ...
    initBricks();
}
</pre>

<p>Now onto the function itself. Add the <code>initBricks()</code> function at the end of our games code, just before the closing &lt;/script&gt; tag, as shown below. To begin with we've included the  <code>brickInfo</code> object, as this will come in handy very soon:</p>

<pre class="brush: js notranslate">function initBricks() {
    brickInfo = {
        width: 50,
        height: 20,
        count: {
            row: 3,
            col: 7
        },
        offset: {
            top: 50,
            left: 60
        },
        padding: 10
    };
}
</pre>

<p>This <code>brickInfo</code> object will hold all the information we need: the width and height of a single brick, the number of rows and columns of bricks we will see on screen, the top and left offset (the location on the canvas where we shall start to draw the bricks) and the padding between each row and column of bricks.</p>

<p>Now, let's start creating the bricks themselves — add an empty group first to contain the bricks, by adding the following line at the bottom of the <code>initBricks()</code> function:</p>

<pre class="brush: js notranslate">bricks = game.add.group();
</pre>

<p>We can loop through the rows and columns to create new brick on each iteration — add the following nested loop below the previous line of code:</p>

<pre class="brush: js notranslate">for(c=0; c&lt;brickInfo.count.col; c++) {
    for(r=0; r&lt;brickInfo.count.row; r++) {
        // create new brick and add it to the group
    }
}
</pre>

<p>This way we will create the exact number of bricks we need and have them all contained in a group. Now we need to add some code inside the nested loop stucture to draw each brick. Fill in the contents as shown below:</p>

<pre class="brush: js notranslate">for(c=0; c&lt;brickInfo.count.col; c++) {
    for(r=0; r&lt;brickInfo.count.row; r++) {
        var brickX = 0;
        var brickY = 0;
        newBrick = game.add.sprite(brickX, brickY, 'brick');
        game.physics.enable(newBrick, Phaser.Physics.ARCADE);
        newBrick.body.immovable = true;
        newBrick.anchor.set(0.5);
        bricks.add(newBrick);
    }
}
</pre>

<p>Here we're looping through the rows and columns to create the new bricks and place them on the screen. The newly created brick is enabled for the Arcade physics engine, it's body is set to be immovable (so it won't move when hit by the ball), and we're also setting the anchor to be in the middle and adding the brick to the group.</p>

<p>The problem currently is that we're painting all the bricks in one place, at coordinates (0,0). What we need to do is draw each brick at its own x and y position. Update the <code>brickX</code> and <code>brickY</code> lines as follows:</p>

<pre class="brush: js notranslate">var brickX = (c*(brickInfo.width+brickInfo.padding))+brickInfo.offset.left;
var brickY = (r*(brickInfo.height+brickInfo.padding))+brickInfo.offset.top;
</pre>

<p>Each <code>brickX</code> position is worked out as <code>brickInfo.width</code> plus <code>brickInfo.padding</code>, multiplied by the column number, <font face="consolas, Liberation Mono, courier, monospace"><span style="background-color: rgba(220, 220, 220, 0.5);">c</span></font>, plus the <code>brickInfo.offset.left</code>; the logic for the <code>brickY</code> is identical except that it uses the values for row number, <font face="consolas, Liberation Mono, courier, monospace"><span style="background-color: rgba(220, 220, 220, 0.5);">r</span></font>, <code>brickInfo.height</code>, and <code>brickInfo.offset.top</code>. Now every single brick can be placed in its correct place, with padding between each brick, and drawn at an offset from the left and top Canvas edges.</p>

<h2 id="Checking_the_initBricks_code">Checking the initBricks() code</h2>

<p>Here is the complete code for the <code>initBricks()</code> function:</p>

<pre class="brush: js notranslate">function initBricks() {
    brickInfo = {
        width: 50,
        height: 20,
        count: {
            row: 3,
            col: 7
        },
        offset: {
            top: 50,
            left: 60
        },
        padding: 10
    }
    bricks = game.add.group();
    for(c=0; c&lt;brickInfo.count.col; c++) {
        for(r=0; r&lt;brickInfo.count.row; r++) {
            var brickX = (c*(brickInfo.width+brickInfo.padding))+brickInfo.offset.left;
            var brickY = (r*(brickInfo.height+brickInfo.padding))+brickInfo.offset.top;
            newBrick = game.add.sprite(brickX, brickY, 'brick');
            game.physics.enable(newBrick, Phaser.Physics.ARCADE);
            newBrick.body.immovable = true;
            newBrick.anchor.set(0.5);
            bricks.add(newBrick);
        }
    }
}
</pre>

<p>If you reload <code>index.html</code> at this point, you should see the bricks printed on screen, at an even distance from one another.</p>

<h2 id="Compare_your_code">Compare your code</h2>

<p>You can check the finished code for this lesson in the live demo below, and play with it to understand better how it works:</p>

<p>{{JSFiddleEmbed("https://jsfiddle.net/end3r/cck2b9e8/","","400")}}</p>

<h2 id="Next_steps">Next steps</h2>

<p>Something is missing though. The ball goes through the bricks without stopping — we need proper <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_Phaser/Collision_detection">collision detection</a>.</p>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_Phaser/Game_over", "Games/Workflows/2D_Breakout_game_Phaser/Collision_detection")}}</p>
